using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

namespace Jefferies.Common.Data.Sql.DataModel
{
	//public abstract class RecordBase
	public class RecordBase
	{
		private ValueList _values;

		/// <summary>
		/// Default constructor
		/// </summary>
		public RecordBase()
		{
			_values = new ValueList();
		}

		/// <summary>
		/// Initialises the RecordBase values using the provided DataRow
		/// </summary>
		/// <param name="dr">DataRow containing the initialising values</param>
		public RecordBase(DataRow dataRow) : this()
		{
			this.Initialize(dataRow);
		}

		protected ValueList Values
		{
			get
			{
				return this._values;
			}
		}

		private void Initialize(DataRow dr)
		{
			for (int i = 0; i < dr.Table.Columns.Count; i++)
			{
				_values.Add(dr.Table.Columns[i].ColumnName, dr[dr.Table.Columns[i].ColumnName]);
			}
		}

		//public abstract void Save();
	}
}
