using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using System.Collections;
using Jefferies.Common.Data.Sql.DataModel;

namespace Jefferies.Common.Data.Collections.GridHelper
{
    [Serializable]
	public class RowItem : IEditableObject
    {
		private RecordBase _data;
		private RecordBase _dataBackup;
		private bool _inTxn	= false;
		private bool _isNew	= true;
		private IList _parent;

		#region properties

		public object Data
		{
			get
			{
				return _data;
			}
			set
			{
				_data = (RecordBase) value;
			}
		}

		private object DataBackup
		{
			get
			{
				return _dataBackup;
			}
			set
			{
				_dataBackup = (RecordBase) value;
			}
		}

		#endregion

		#region IEditableObject Members

		void IEditableObject.BeginEdit()
		{
			if (!_inTxn)
			{
				_dataBackup	= _data;
				_inTxn		= true;
			}
		}

		void IEditableObject.CancelEdit()
		{
			if (_inTxn)
			{
				_data	= _dataBackup;
				_inTxn	= false;
				if (_isNew) Parent.Remove(this);
			}
		}

		void IEditableObject.EndEdit()
		{
			if (_inTxn)
			{
				_dataBackup = new RecordBase();
				_inTxn		= false;
				_isNew		= false;
			}
		}

		#endregion

		//internal RowItemList<RowItem> Parent
		internal IList Parent
		{
			get
			{
				return _parent;
			}
			set
			{
				_parent = value;
			}
		}

		public bool IsNew
		{
			get
			{
				return _isNew;
			}
			set
			{
				_isNew	= value;
			}
		}
	}
}
