using System;
using System.Collections.Generic;
using System.Collections;
using System.Collections.Specialized;
using System.Text;
using System.Data.SqlClient;

namespace Jefferies.Common.Data.Sql.DataModel
{
	public class ValueList : NameObjectCollectionBase
	{
		public ValueList()
			: base()
		{
		}

		/// <summary>
		/// Adds an entry with the specified name and value
		/// </summary>
		/// <param name="name"></param>
		/// <param name="conn"></param>
		public void Add(string name, object value)
		{
			base.BaseAdd(name, value);
		}

		/// <summary>
		/// Removes the entries with the specified name
		/// </summary>
		/// <param name="name"></param>
		public void Remove(string name)
		{
			base.BaseRemove(name);
		}

		public bool Contains(string name)
		{
			return (this.Get(name) != null);
		}

		public bool Contains(object value)
		{
			for (int i = 0; i < this.Count; i++)
			{
				if (this[i] == value) return true;
			}
			return false;
		}

		/// <summary>
		/// Removes all entries from the collection
		/// </summary>
		public void Clear()
		{
			base.BaseClear();
		}

		/// <summary>
		/// Gets value for specified index position
		/// </summary>
		/// <param name="index"></param>
		/// <returns></returns>
		public object Get(int index)
		{
			return (object) base.BaseGet(index);
		}

		/// <summary>
		/// Gets value for specified field name
		/// </summary>
		/// <param name="index"></param>
		/// <returns></returns>
		public object Get(string index)
		{
			return (object) base.BaseGet(index);
		}

		/// <summary>
		/// Gets all keys in the collection
		/// </summary>
		/// <returns></returns>
		public string[] GetAllKeys()
		{
			return base.BaseGetAllKeys();
		}

		/// <summary>
		/// Gets all values in the collection
		/// </summary>
		/// <returns></returns>
		//public object[] GetAllValues()
		//{
		//    //return (object[]) base.BaseGetAllValues(typeof(object));
		//    return null;
		//}

		/// <summary>
		/// Gets the name of the entry at the specified position
		/// </summary>
		/// <param name="index"></param>
		/// <returns></returns>
		public string GetKey(int index)
		{
			return base.BaseGetKey(index);
		}

		/// <summary>
		/// Sets the value of the entry at the specified position
		/// </summary>
		/// <param name="index"></param>
		/// <param name="value"></param>
		public void Set(int index, object value)
		{
			base.BaseSet(index, value);
		}

		/// <summary>
		/// Sets the value of the entry at the specified index
		/// </summary>
		/// <param name="index"></param>
		/// <param name="value"></param>
		public void Set(string index, object value)
		{
			base.BaseSet(index, value);
		}

		public object this[string index]
		{
			get
			{
				return this.Get(index);
			}
			set
			{
				this.Set(index, value);
			}
		}

		public object this[int index]
		{
			get
			{
				return this.Get(index);
			}
			set
			{
				this.Set(index, value);
			}
		}
	}
}